SystemOrganization addCategory: #DocumentLogic!

Object subclass: #DocumentLogic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

DocumentLogic subclass: #Doc
	instanceVariableNames: 'isNew isDirty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!Doc methodsFor: 'testing' stamp: 'HwaJong 10/5/2012 14:28'!
hasSaveMedium
^isNew not! !

!Doc methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:10'!
hasUnsavedChange
^isDirty! !

!Doc methodsFor: 'initialize-release' stamp: 'HwaJong 10/3/2012 16:40'!
initialize 
super initialize.
isNew := true.
isDirty := false.! !

!Doc methodsFor: 'actions' stamp: 'HwaJong 10/3/2012 18:06'!
load
isNew := false.! !

!Doc methodsFor: 'actions' stamp: 'HwaJong 10/3/2012 17:49'!
modify
isDirty := true.! !

!Doc methodsFor: 'actions' stamp: 'HwaJong 10/3/2012 22:13'!
saveAs
isNew := false.
isDirty := false.! !

!DocumentLogic methodsFor: 'query' stamp: 'HwaJong 10/5/2012 14:30'!
whatAreYouGoingToDoWhenUserCloses
^self hasUnsavedChange
	ifTrue: [self hasSaveMedium not
		ifTrue: [#askUserIfHeWantsToSaveAsBeForeClosingAndThenClose]
		ifFalse: [#askUserIfHeWantsToSaveBeForeClosingAndThenClose]]
	ifFalse: [#justClose]

! !

!DocumentLogic methodsFor: 'query' stamp: 'HwaJong 10/5/2012 14:30'!
whatAreYouGoingToDoWhenUserLoads
^self hasUnsavedChange
	ifTrue: [self hasSaveMedium not 
		ifTrue: [#askUserSaveAsOrDiscardThenLoad] 
		ifFalse: [#askUserSaveOrSaveAsOrDiscardThenLoad]]
	ifFalse: [#load]
! !

!DocumentLogic methodsFor: 'query' stamp: 'HwaJong 10/5/2012 14:30'!
whatAreYouGoingToDoWhenUserSaves
^self hasSaveMedium not
	ifTrue: [#saveAs]
	ifFalse: [#saveToLoadMedium]! !

TestCase subclass: #DocTest
	instanceVariableNames: 'doc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

DocTest subclass: #DirtyLoadedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!DirtyLoadedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:09'!
isAbstract 
^false! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:09'!
docShouldBeNew
^false! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:22'!
docShouldHaveSaveMedium
^true! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:44'!
docShouldHaveUnsavedChange
^true! !

!DirtyLoadedDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:09'!
setUp
super setUp.
doc load.
doc modify.! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/4/2012 22:41'!
whatShouldDocDoWhenUserCloses
^#askUserIfHeWantsToSaveBeForeClosingAndThenClose! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:11'!
whatShouldDocDoWhenUserLoads
^#askUserSaveOrSaveAsOrDiscardThenLoad! !

!DirtyLoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:12'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

DocTest subclass: #DirtyNewDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!DirtyNewDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^false! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:55'!
docShouldBeNew
^true! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:22'!
docShouldHaveSaveMedium
^false! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:43'!
docShouldHaveUnsavedChange
^true! !

!DirtyNewDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 17:53'!
setUp
super setUp.
doc := Doc new.
doc modify.! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/4/2012 22:42'!
whatShouldDocDoWhenUserCloses
^#askUserIfHeWantsToSaveAsBeForeClosingAndThenClose! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/4/2012 00:44'!
whatShouldDocDoWhenUserLoads
^#askUserSaveAsOrDiscardThenLoad! !

!DirtyNewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserSaves
^#saveAs! !

DocTest subclass: #DirtySavedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!DirtySavedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:58'!
isAbstract
^false! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:01'!
docShouldBeNew
^false! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:23'!
docShouldHaveSaveMedium
^true! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:00'!
docShouldHaveUnsavedChange
^true! !

!DirtySavedDocTest methodsFor: 'running' stamp: 'HwaJong 10/5/2012 13:58'!
setUp
super setUp.
doc saveAs.
doc modify.! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:03'!
whatShouldDocDoWhenUserCloses
^#askUserIfHeWantsToSaveBeForeClosingAndThenClose! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:05'!
whatShouldDocDoWhenUserLoads
^#askUserSaveOrSaveAsOrDiscardThenLoad! !

!DirtySavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:06'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

!DocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^true! !

!DocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:04'!
setUp
super setUp.
doc := Doc new.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 14:21'!
testHasSaveMedium
self assert: doc hasSaveMedium equals: self docShouldHaveSaveMedium! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/5/2012 13:40'!
testHasUnsavedChange
self assert: doc hasUnsavedChange equals: self docShouldHaveUnsavedChange! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/4/2012 22:38'!
testdWhatAreYouGoingToDoWhenUserCloses
self assert: doc whatAreYouGoingToDoWhenUserCloses equals: self whatShouldDocDoWhenUserCloses.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/3/2012 18:02'!
testdWhatAreYouGoingToDoWhenUserLoads
self assert: doc whatAreYouGoingToDoWhenUserLoads equals: self whatShouldDocDoWhenUserLoads.! !

!DocTest methodsFor: 'tests' stamp: 'HwaJong 10/3/2012 18:02'!
testdWhatAreYouGoingToDoWhenUserSaves
self assert: doc whatAreYouGoingToDoWhenUserSaves equals: self whatShouldDocDoWhenUserSaves.! !

DocTest subclass: #LoadedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!LoadedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:04'!
isAbstract
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:05'!
docShouldBeNew
^false! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:23'!
docShouldHaveSaveMedium
^true! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:42'!
docShouldHaveUnsavedChange
^false! !

!LoadedDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 18:05'!
setUp
super setUp.
doc load.! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/4/2012 22:43'!
whatShouldDocDoWhenUserCloses
^#justClose! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:07'!
whatShouldDocDoWhenUserLoads
^#load! !

!LoadedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:07'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !

DocTest subclass: #NewDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!NewDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:54'!
isAbstract
^false! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 17:55'!
docShouldBeNew
^true! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:23'!
docShouldHaveSaveMedium
^false! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:40'!
docShouldHaveUnsavedChange
^false! !

!NewDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 17:52'!
setUp
super setUp.
doc := Doc new.! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 12:26'!
whatShouldDocDoWhenUserCloses
^#justClose! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserLoads
^#load! !

!NewDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 18:02'!
whatShouldDocDoWhenUserSaves
^#saveAs! !

DocTest subclass: #SavedDocTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DocumentLogic'!

!SavedDocTest classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:10'!
isAbstract
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:11'!
docShouldBeNew
^false! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 14:24'!
docShouldHaveSaveMedium
^true! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/5/2012 13:41'!
docShouldHaveUnsavedChange
^false! !

!SavedDocTest methodsFor: 'running' stamp: 'HwaJong 10/3/2012 22:13'!
setUp
super setUp.
doc saveAs.! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/4/2012 22:43'!
whatShouldDocDoWhenUserCloses
^#justClose! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:13'!
whatShouldDocDoWhenUserLoads
^#load! !

!SavedDocTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/3/2012 22:14'!
whatShouldDocDoWhenUserSaves
^#saveToLoadMedium! !
